import { render, screen } from "@testing-library/react";
import userEvent from "@testing-library/user-event";
import MyComponent from "./MyComponent";

describe("MyComponent", () => {
  it("renders a <div>", () => {
    render(<MyComponent />);
    expect(screen.getByRole("div")).toBeInTheDocument();
  });

  it("accepts a `className` prop", () => {
    render(<MyComponent className="test-class" />);
    expect(screen.getByRole("div")).toHaveClass("test-class");
  });

  it("triggers `onClick` when clicked", async () => {
    const onClick = vi.fn();
    render(<MyComponent onClick={onClick} />);
    const nextButton = screen.getByRole("button");
    const user = userEvent.setup();
    await user.click(nextButton);
    expect(onClick).toHaveBeenCalled();
  });
});
